/******************************************
	PURPOSE:	Methods that help the HCSR04 sensor measure distance in CM
	CREATOR:    John Hook
	DATE:		10/15/2014
*******************************************/

#include "HCSR04.h"

HCSR04ProxSensor::HCSR04ProxSensor(int echoPin, int triggerPin) //This is the constructor.
{
	_echoPin = echoPin; //echo ultasonic sensor that receives the reflected signal
	_triggerPin = triggerPin; //sends a pulse
}

float HCSR04ProxSensor::readSensor(){

	pinMode(_echoPin, INPUT); // initialize pins as INPUT and OUTPUT.
	pinMode(_triggerPin, OUTPUT);

	_lastValue = _distance; // save "current value" (_distance) into the _lastValue private variable before it is changed again.

	digitalWrite(_triggerPin, HIGH); // makes a 10 micro second pulse.
	delayMicroseconds(10);
	digitalWrite(_triggerPin, LOW);

	_distance = pulseIn(_echoPin, HIGH); // gets the distance.
	_distance = _distance / 58; //distance is in cm
	return(_distance);
}

float HCSR04ProxSensor::getLastValue(){
	return(_lastValue); // return the last value.
}
